import { Worker } from 'node:worker_threads';
import type { RolldownPlugin } from '../plugin';
import { ParallelJsPluginRegistry } from '../binding';
export type WorkerData = {
    registryId: number;
    pluginInfos: ParallelPluginInfo[];
    threadNumber: number;
};
type ParallelPluginInfo = {
    index: number;
    fileUrl: string;
    options: unknown;
};
export declare function initializeParallelPlugins(plugins: RolldownPlugin[]): Promise<{
    registry: ParallelJsPluginRegistry;
    stopWorkers: () => Promise<void>;
} | undefined>;
export declare function initializeWorkers(registryId: number, count: number, pluginInfos: ParallelPluginInfo[]): Promise<Worker[]>;
export {};
